/* GCC */

#define M 100   //   ,      

#include <stdio.h>

int v[3];   //     v[0] == a, v[1] == b, v[2] == c
int n, ans; // ʳ ,   ,  ,    
int c[3], step; // ,      ,    ,
                //          (0, 0, 0)
int steps[M + 1][M + 1][M + 1]; //  steps[x][y][z]    ,  
                                //  (x, y, z)      (0, 0, 0);
                                //  ,      ,    0
//  M+1  M     ,    
//     M+1 :  0  M 
int q[(M + 1) * (M + 1) * (M + 1)][3], q_start, q_end;  //   ,   
                                                        //    (0, 0, 0)

/*  ,      steps */
void init()
{
    ans = 0;

    for (int x = 0; x <= M; x++)
        for (int y = 0; y <= M; y++)
            for (int z = 0; z <= M; z++)
                steps[x][y][z] = 0;

    q_start = q_end = 0;
}

/*   (x, y, z)       steps,   
   ,     x, y  z    ( n);
         ,    */
void add(int x, int y, int z)
{
    if (steps[x][y][z] != 0)    //         
        return;                 // ,     

    if ((x == n || y == n || z == n) && ans == 0)   //     
        ans = step;                                 // n ,  

    steps[x][y][z] = step;  //   :
                            //        step
    q[q_end][0] = x;
    q[q_end][1] = y;    //    
    q[q_end][2] = z;
    q_end++;
}

/*     to (0 <= to <= 2)    v[to] */
void fill(int to)
{
    int cc[3];  //  ,     
    for (int i = 0; i < 3; i++) //      
        cc[i] = c[i];
    cc[to] = v[to]; //    
    add(cc[0], cc[1], cc[2]);   //     
}

/*     from (0 <= from <= 2) */
void empty(int from)
{
    int cc[3];  //  ,     
    for (int i = 0; i < 3; i++) //      
        cc[i] = c[i];
    cc[from] = 0; //    
    add(cc[0], cc[1], cc[2]);   //     
}

/*     from   to (0 <= from <= 2, 0 <= to <= 2, from != to) */
void pour(int from, int to)
{
    int cc[3];  //  ,     
    for (int i = 0; i < 3; i++) //      
        cc[i] = c[i];
    cc[to] = c[to] + c[from] > v[to] ?          //   ,   :
                               v[to] :          //     ,   
                               c[to] + c[from]; //   
    cc[from] -= cc[to] - c[to]; //     ,   ,
                                //   ,      
    add(cc[0], cc[1], cc[2]);   //     
}

int main()
{
    freopen("math.in", "r", stdin);
    freopen("math.out", "w", stdout);

    //     a, b, c   v:
    scanf("%d %d %d\n%d", &v[0], &v[1], &v[2], &n);

    init();

    step = 0;
    add(0, 0, 0);   //      (0, 0, 0)

    while (ans == 0 && q_end > q_start) //         
    {
        for (int i = 0; i < 3; i++) //    c    
            c[i] = q[q_start][i];
        q_start++;  // ³       

        //       ,   :
        step = steps[c[0]][c[1]][c[2]] + 1; //  ,    , 
                                            //    1    
        fill(0);    //   
        fill(1);    //   
        fill(2);    //   
        empty(0);   //   
        empty(1);   //   
        empty(2);   //   
        pour(0, 1); //       
        pour(1, 0); //       
        pour(1, 2); //       
        pour(2, 1); //       
        pour(2, 0); //       
        pour(0, 2); //       
    }

    //   ( 0,     ,   n ):
    printf("%d\n", ans);

    return 0;
}
