/* GCC */

#include <iostream>
#include <cstdio>

inline int max (int a, int b)
{
       if (a > b)
          return a;
       if (b > a)
          return b;
       
       return a;
       }

int main ()
{
    FILE* pIn = fopen ("math.in", "r");
    FILE* pOut = fopen ("math.out", "w");
    int a, b, c;
    int n;
    int q = 0;
    
    fscanf (pIn, "%i%i%i%i", &a, &b, &c, &n);
    
    if ( (n > a) || (n > b) || (n > c) ) {
         q = 0;
         fprintf (pOut, "%i\n", q);
         return 0;
         }
    
    if ( (n == a) || (n == b) || (n == c) ) {
       q = 1;
       fprintf (pOut, "%i\n", q);
       return 0;
       }
    
    if ( n % max(a,b) == 0 )
       q = 2 * (n/max(a,b));
    if ( n % max(b,c) == 0 )
       q = 2 * (n/max(b,c));
    if ( n % max(a,c) == 0 )
       q = 2 * (n/max(a,c));
    if (q > 1)
       fprintf (pOut, "%i\n", q);
    else
        return 0;
    
       return 0;
    }
